VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGamma"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub CopyMemory Lib "Kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function GetDeviceGammaRamp Lib "GDI32.dll" (ByVal hDc As Long, lpV As Any) As Long
Private Declare Function SetDeviceGammaRamp Lib "GDI32.dll" (ByVal hDc As Long, lpV As Any) As Long
Private Declare Function GetDC Lib "User32.dll" (ByVal hWnd As Long) As Long

Private arrGammaSave(0 To 255, 0 To 2) As Integer
Private bGammaSaved As Boolean
Private bRestoreOnExit As Boolean
Private MIN_POS As Long
Private MAX_POS As Long
Private POS_FACTOR As Long

Public Property Let MIN(ByVal lValue As Long)
    MIN_POS = lValue
End Property
Public Property Let MAX(ByVal lValue As Long)
    MAX_POS = lValue
End Property
Public Property Let RESTORE_ON_EXIT(ByVal bValue As Boolean)
    bRestoreOnExit = bValue
End Property

Private Sub Class_Initialize()
    If Not GetDeviceGammaRamp(GetDC(0), arrGammaSave(0, 0)) = 0 Then
        bGammaSaved = True '### Safety check
        '### Set class defaults here ###
        MIN_POS = 0
        MAX_POS = 40
        POS_FACTOR = 10.01
        bRestoreOnExit = True
        '### End defaults ###
    Else
        bGammaSaved = False
    End If
End Sub
Private Sub Class_Terminate()
    If bRestoreOnExit = True And bGammaSaved = True Then SetDeviceGammaRamp GetDC(0), arrGammaSave(0, 0)
End Sub

Public Sub RestoreGamma()
    If bGammaSaved = True Then SetDeviceGammaRamp GetDC(0), arrGammaSave(0, 0)
End Sub
Public Function SetGamma(dValue As Double)
    If bGammaSaved = False Then Exit Function
    SetGammaPos ((MAX_POS - dValue) / POS_FACTOR)
End Function
Public Function GetSavedGamma() As Integer
    If bGammaSaved = False Then Exit Function
    GetSavedGamma = GetGammaPos()
End Function

Private Sub SetGammaPos(Gamma As Double)
    If bGammaSaved = False Then Exit Sub
    Dim arrRamp(0 To 255, 0 To 2) As Integer
    Dim dblTest As Double
    Dim l As Long
    Dim i As Integer
    For i = 0 To 255
        dblTest = (((i + 1) / 256.01) ^ Gamma) * 65535 + 0.5
        If dblTest > 65535 Then
            l = 65535
        Else
            l = CLng(dblTest)
        End If
        '### Set the Low Word (2 bytes).
        arrRamp(i, 0) = LOWORD(l)
        arrRamp(i, 1) = LOWORD(l)
        arrRamp(i, 2) = LOWORD(l)
    Next i
    SetDeviceGammaRamp GetDC(0), arrRamp(0, 0)
End Sub
Private Function GetGammaPos() As Integer
    If bGammaSaved = False Then Exit Function
    On Error Resume Next
    Dim rgb(2) As Double
    Dim i As Integer
    Dim j As Integer
    rgb(0) = 1.01
    rgb(1) = 1.01
    rgb(2) = 1.01
    For i = 0 To 2
        Dim Csum As Double
        Dim Ccount As Integer
        Csum = 0
        Ccount = 0
        For j = 0 To 255
            If j <> 0 And arrGammaSave(j, i) <> 0 And arrGammaSave(j, i) <> 65536 Then
                Dim a As Double
                Dim b As Double
                Dim c As Double
                b = (j Mod 256) / 256.01
                a = arrGammaSave(j, i) / 65536.01
                c = Log(a) / Log(b)
                Csum = Csum + c
                Ccount = Ccount + 1
            End If
        Next j
        rgb(i) = Csum / Ccount
    Next i
    GetGammaPos = Int(MAX_POS - (rgb(0) * POS_FACTOR))
End Function
Private Function LOWORD(ByVal lng As Long) As Integer
    CopyMemory LOWORD, lng, 2
End Function
